Index: issm/trunk/src/m/classes/basalforcings.py
===================================================================
--- issm/trunk/src/m/classes/basalforcings.py	(revision 18081)
+++ issm/trunk/src/m/classes/basalforcings.py	(revision 18301)
@@ -14,7 +14,7 @@
 
 	def __init__(self): # {{{
-		self.melting_rate             = float('NaN')
-		self.melting_rate_correction  = float('NaN')
-		self.geothermalflux           = float('NaN')
+		self.groundedice_melting_rate  = float('NaN')
+		self.floatingice_melting_rate  = float('NaN')
+		self.geothermalflux            = float('NaN')
 
 		#set defaults
@@ -25,6 +25,6 @@
 		string="   basal forcings parameters:"
 
-		string="%s\n%s"%(string,fielddisplay(self,"melting_rate","basal melting rate (positive if melting) [m/yr]"))
-		string="%s\n%s"%(string,fielddisplay(self,"melting_rate_correction","additional melting applied to compensate for dh/dt [m/yr]"))
+		string="%s\n%s"%(string,fielddisplay(self,"groundedice_melting_rate","basal melting rate (positive if melting) [m/yr]"))
+		string="%s\n%s"%(string,fielddisplay(self,"floatingice_melting_rate","basal melting rate (positive if melting) [m/yr]"))
 		string="%s\n%s"%(string,fielddisplay(self,"geothermalflux","geothermal heat flux [W/m^2]"))
 		return string
@@ -32,7 +32,11 @@
 	def initialize(self,md): # {{{
 
-		if numpy.all(numpy.isnan(self.melting_rate)):
-			self.melting_rate=numpy.zeros((md.mesh.numberofvertices,1))
-			print "      no basalforcings.melting_rate specified: values set as zero"
+		if numpy.all(numpy.isnan(self.groundedice_melting_rate)):
+			self.groundedice_melting_rate=numpy.zeros((md.mesh.numberofvertices,1))
+			print "      no basalforcings.groundedice_melting_rate specified: values set as zero"
+
+		if numpy.all(numpy.isnan(self.floatingice_melting_rate)):
+			self.floatingice_melting_rate=numpy.zeros((md.mesh.numberofvertices,1))
+			print "      no basalforcings.floatingice_melting_rate specified: values set as zero"
 
 		return self
@@ -44,11 +48,14 @@
 
 		if MasstransportAnalysisEnum() in analyses and not (solution==TransientSolutionEnum() and not md.transient.ismasstransport):
-			md = checkfield(md,'fieldname','basalforcings.melting_rate','NaN',1,'forcing',1)
+			md = checkfield(md,'fieldname','basalforcings.groundedice_melting_rate','NaN',1,'forcing',1)
+			md = checkfield(md,'fieldname','basalforcings.floatingice_melting_rate','NaN',1,'forcing',1)
 
 		if BalancethicknessAnalysisEnum() in analyses:
-			md = checkfield(md,'fieldname','basalforcings.melting_rate','NaN',1,'size',[md.mesh.numberofvertices])
+			md = checkfield(md,'fieldname','basalforcings.groundedice_melting_rate','NaN',1,'size',[md.mesh.numberofvertices])
+			md = checkfield(md,'fieldname','basalforcings.floatingice_melting_rate','NaN',1,'size',[md.mesh.numberofvertices])
 
 		if ThermalAnalysisEnum() in analyses and not (solution==TransientSolutionEnum() and not md.transient.isthermal):
-			md = checkfield(md,'fieldname','basalforcings.melting_rate','NaN',1,'forcing',1)
+			md = checkfield(md,'fieldname','basalforcings.groundedice_melting_rate','NaN',1,'forcing',1)
+			md = checkfield(md,'fieldname','basalforcings.floatingice_melting_rate','NaN',1,'forcing',1)
 			md = checkfield(md,'fieldname','basalforcings.geothermalflux','NaN',1,'forcing',1,'>=',0)
 
@@ -59,6 +66,7 @@
 		yts=365.0*24.0*3600.0
 
-		WriteData(fid,'object',self,'fieldname','melting_rate','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1)
-		WriteData(fid,'object',self,'fieldname','melting_rate_correction','format','DoubleMat','mattype',1,'scale',1./yts)
+		WriteData(fid,'enum',BasalforcingsEnum(),'data',FloatingMeltRateEnum(),'format','Integer');
+		WriteData(fid,'object',self,'fieldname','groundedice_melting_rate','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1)
+		WriteData(fid,'object',self,'fieldname','floatingice_melting_rate','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1)
 		WriteData(fid,'object',self,'fieldname','geothermalflux','format','DoubleMat','mattype',1,'forcinglength',md.mesh.numberofvertices+1)
 	# }}}
Index: issm/trunk/src/m/classes/clusters/generic.m
===================================================================
--- issm/trunk/src/m/classes/clusters/generic.m	(revision 18081)
+++ issm/trunk/src/m/classes/clusters/generic.m	(revision 18301)
@@ -20,4 +20,5 @@
 		valgrindsup=[issmdir() '/externalpackages/valgrind/issm.supp'];
 		verbose=1;
+		shell='/bin/sh';
 		%}}}
 	end
@@ -70,4 +71,5 @@
 			disp(sprintf('    valgrindsup: %s',cluster.valgrindsup));
 			disp(sprintf('    verbose: %s',cluster.verbose));
+			disp(sprintf('    shell: %s',cluster.shell));
 		end
 		%}}}
@@ -87,9 +89,9 @@
 
 				fid=fopen([modelname '.queue'],'w');
-				fprintf(fid,'#!/bin/sh\n');
+				fprintf(fid,'#!%s\n',cluster.shell);
 				if ~isvalgrind,
 					if cluster.interactive
 						if IssmConfig('_HAVE_MPI_'),
-							fprintf(fid,'mpiexec -np %i %s/issm.exe %s %s %s ',cluster.np,cluster.codepath,EnumToString(solution),[cluster.executionpath '/' dirname],modelname);
+							fprintf(fid,'mpiexec -np %i %s/issm.exe %s %s %s \n',cluster.np,cluster.codepath,EnumToString(solution),[cluster.executionpath '/' dirname],modelname);
 						else
 							fprintf(fid,'%s/issm.exe %s %s %s ',cluster.codepath,EnumToString(solution),[cluster.executionpath '/' dirname],modelname);
@@ -202,4 +204,12 @@
 
 			if ~ispc,
+
+				%figure out what shell extension we will use:
+				if isempty(strfind(cluster.shell,'csh')),
+					shellext='sh';
+				else
+					shellext='csh';
+				end
+
 				%compress the files into one zip.
 				compressstring=['tar -zcf ' dirname '.tar.gz '];
@@ -216,5 +226,5 @@
 
 				if cluster.verbose, disp('launching solution sequence on remote cluster'); end
-				launchcommand=['source ' cluster.etcpath '/environment.sh && cd ' cluster.executionpath ' && rm -rf ./' dirname ' && mkdir ' dirname ...
+				launchcommand=['source ' cluster.etcpath '/environment.' shellext ' && cd ' cluster.executionpath ' && rm -rf ./' dirname ' && mkdir ' dirname ...
 					' && cd ' dirname ' && mv ../' dirname '.tar.gz ./ && tar -zxf ' dirname '.tar.gz  && source  ' modelname '.queue '];
 				issmssh(cluster.name,cluster.login,cluster.port,launchcommand);
Index: issm/trunk/src/m/classes/damage.m
===================================================================
--- issm/trunk/src/m/classes/damage.m	(revision 18081)
+++ issm/trunk/src/m/classes/damage.m	(revision 18301)
@@ -9,80 +9,80 @@
 		isdamage            = 0;
 		D                   = NaN;
-		law                 = '';
+		law                 = 0;
 		spcdamage           = NaN; 
-		max_damage          = NaN;
+		max_damage          = 0;
 	
 		%numerical
-		stabilization       = NaN;
-		maxiter             = NaN;
+		stabilization       = 0;
+		maxiter             = 0;
 		elementinterp       = '';
-		penalty_threshold   = NaN;
-		penalty_lock        = NaN;
-		penalty_factor      = NaN;
+		penalty_threshold   = 0;
+		penalty_lock        = 0;
+		penalty_factor      = 0;
 		
 		%general parameters for evolution law: 
-		stress_threshold    = NaN;
-		c1                  = NaN;
-		c2                  = NaN;
-		c3                  = NaN;
-		c4                  = NaN;
-		healing             = NaN;
-		equiv_stress		  = NaN;
+		stress_threshold    = 0;
+		c1                  = 0;
+		c2                  = 0;
+		c3                  = 0;
+		c4                  = 0;
+		healing             = 0;
+		equiv_stress		  = 0;
 		requested_outputs   = {};
 	end
 	methods
-        function createxml(obj,fid) % {{{
-            fprintf(fid, '\n\n');
-            fprintf(fid, '%s\n', '<!-- damage -->');
-            fprintf(fid, '%s\n', '<!-- Note: this class depends on different input of law -->');
-            
-            %fprintf(fid,'%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="law" type="logical"',           '" default="',                num2str(obj.law),'">',   '     <section name="damage" />','     <help> damage law (string) from {"undamaged","pralong"} </help>','</parameter>');
-            % drop-down 
-            fprintf(fid,'%s%s%s%s%s\n\t%s\n','<parameter key ="law" type="','alternative','" optional="','false','">','<section name="damage" />');
-            
-            % law = 'undamage'
-            fprintf(fid,'\t%s%s%s%s%s\n\t\t%s\n','<option value="undamage" type="','string','" default="','true','">','<help> law = undamage </help>');
-            % footer for option
-            fprintf(fid,'\t%s\n%s\n','</option>');
-            
-            % law = 'pralong'
-            fprintf(fid,'\t%s%s%s%s%s\n\t\t%s\n','<option value="pralong" type="','string','" default="','false','">','<help> law = pralong </help>');
-                
-            fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',   '<parameter key ="stress_threshold" type="',class(obj.stress_threshold),'" default="',num2str(obj.stress_threshold),'">','<help> damage stress threshold [Pa] </help>','</parameter>');
-            fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',	'<parameter key ="c1" type="', class(obj.c1),'" default="',   num2str(obj.c1),'">',   '<help> damage parameter 1 </help>','</parameter>');
-            fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',  	'<parameter key ="c2" type="',          class(obj.c2),'" default="',            num2str(obj.c2),'">','<help> damage parameter 2 </help>','</parameter>');
-            fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',  	'<parameter key ="c3" type="',          class(obj.c3),'" default="',            num2str(obj.c3),'">','<help> damage parameter 3 [W/m^2] </help>','</parameter>');
-            fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',  	'<parameter key ="c4" type="',            class(obj.c4),'" default="',              num2str(obj.c4),'">','<help> damage parameter 4 </help>','</parameter>');
-            fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',  	'<parameter key ="healing" type="', class(obj.healing),'" default="',   num2str(obj.healing),'">','<help> damage healing parameter 1 </help>','</parameter>');
-            fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',  	'<parameter key ="equiv_stress" type="',          class(obj.equiv_stress),'" default="',convert2str(obj.equiv_stress),'">','<help> 0: von Mises </help>','</parameter>');
-            fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',  	'<parameter key ="requested_outputs" type="',          class(obj.requested_outputs),'" default="',convert2str(obj.requested_outputs),'">','<help> additional outputs requested </help>','</parameter>');
-             
-                
-            % footer for option
-            fprintf(fid,'\t%s\n%s\n','</option>');
-                 
-            
-            % footer for drop-down
-            fprintf(fid,'\t%s\n%s\n%s','<help> damage law (string) from {"undamaged","pralong"} </help>','</parameter>');
-            
-            
+		function createxml(obj,fid) % {{{
+			fprintf(fid, '\n\n');
+			fprintf(fid, '%s\n', '<!-- damage -->');
+			fprintf(fid, '%s\n', '<!-- Note: this class depends on different input of law -->');
+
+			%fprintf(fid,'%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="law" type="logical"',           '" default="',                num2str(obj.law),'">',   '     <section name="damage" />','     <help> damage law (string) from {"undamaged","pralong"} </help>','</parameter>');
+			% drop-down 
+			fprintf(fid,'%s%s%s%s%s\n\t%s\n','<parameter key ="law" type="','alternative','" optional="','false','">','<section name="damage" />');
+
+			% law = 'undamage'
+			fprintf(fid,'\t%s%s%s%s%s\n\t\t%s\n','<option value="undamage" type="','string','" default="','true','">','<help> law = undamage </help>');
+			% footer for option
+			fprintf(fid,'\t%s\n%s\n','</option>');
+
+			% law = 'pralong'
+			fprintf(fid,'\t%s%s%s%s%s\n\t\t%s\n','<option value="pralong" type="','string','" default="','false','">','<help> law = pralong </help>');
+
+			fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',   '<parameter key ="stress_threshold" type="',class(obj.stress_threshold),'" default="',num2str(obj.stress_threshold),'">','<help> damage stress threshold [Pa] </help>','</parameter>');
+			fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',	'<parameter key ="c1" type="', class(obj.c1),'" default="',   num2str(obj.c1),'">',   '<help> damage parameter 1 </help>','</parameter>');
+			fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',  	'<parameter key ="c2" type="',          class(obj.c2),'" default="',            num2str(obj.c2),'">','<help> damage parameter 2 </help>','</parameter>');
+			fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',  	'<parameter key ="c3" type="',          class(obj.c3),'" default="',            num2str(obj.c3),'">','<help> damage parameter 3 [W/m^2] </help>','</parameter>');
+			fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',  	'<parameter key ="c4" type="',            class(obj.c4),'" default="',              num2str(obj.c4),'">','<help> damage parameter 4 </help>','</parameter>');
+			fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',  	'<parameter key ="healing" type="', class(obj.healing),'" default="',   num2str(obj.healing),'">','<help> damage healing parameter 1 </help>','</parameter>');
+			fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',  	'<parameter key ="equiv_stress" type="',          class(obj.equiv_stress),'" default="',convert2str(obj.equiv_stress),'">','<help> 0: von Mises </help>','</parameter>');
+			fprintf(fid,'\t\t%s%s%s%s%s\n\t\t\t%s\n\t\t%s\n',  	'<parameter key ="requested_outputs" type="',          class(obj.requested_outputs),'" default="',convert2str(obj.requested_outputs),'">','<help> additional outputs requested </help>','</parameter>');
+
+
+			% footer for option
+			fprintf(fid,'\t%s\n%s\n','</option>');
+
+
+			% footer for drop-down
+			fprintf(fid,'\t%s\n%s\n%s','<help> damage law (string) from {"undamaged","pralong"} </help>','</parameter>');
+
+
 			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="D" type="',              class(obj.D),'" default="',                  num2str(obj.D),'">',              '     <section name="damage" />','     <help> damage tensor (scalar) </help>','</parameter>');
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="law" type="',            class(obj.law),'" default="',                num2str(obj.law),'">',   '     <section name="damage" />','     <help> damage law (string) from {"undamaged","pralong"} </help>','</parameter>');
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="spcdamage" type="',      class(obj.spcdamage),'" default="',          num2str(obj.spcdamage),'">',            '     <section name="damage" />','     <help> damage constraints (NaN means no constraint) </help>','</parameter>');
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="max_damage" type="',     class(obj.max_damage),'" default="',         num2str(obj.max_damage),'">',            '     <section name="damage" />','     <help> maximum possible damage (0&amp;lt;=max_damage&amp;lt;1) </help>','</parameter>');
-             
-            % stabilization (0,1, or 2) drop-down
-            fprintf(fid,'%s\n%s\n%s\n%s\n',    '<parameter key ="stabilization" type="alternative" optional="false">','     <section name="damage" />','     <help> 0: no, 1: artificial_diffusivity, 2: SUPG </help>');
-            fprintf(fid, '%s\n', '       <option value="0" type="string" default="true"></option>');
-            fprintf(fid, '%s\n', '       <option value="1" type="string" default="false"></option>');
-            fprintf(fid, '%s\n', '       <option value="2" type="string" default="false"></option>');
-            fprintf(fid, '%s\n','</parameter>');
-            
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="maxiter" type="',             class(obj.maxiter),'" default="',   num2str(obj.maxiter),'">',   '     <section name="damage" />','     <help> maximum number of non linear iterations </help>','</parameter>');
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="penalty_lock" type="',        class(obj.penalty_lock),'" default="',            num2str(obj.penalty_lock),'">',            '     <section name="damage" />','     <help> stabilize unstable damage constraints that keep zigzagging after n iteration (default is 0, no stabilization) </help>','</parameter>');
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="penalty_threshold" type="',   class(obj.penalty_threshold),'" default="',            num2str(obj.penalty_threshold),'">',            '     <section name="damage" />','     <help> threshold to declare convergence of damage evolution solution (default is 0) </help>','</parameter>');
-            fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="penalty_factor" type="',      class(obj.penalty_factor),'" default="',            num2str(obj.penalty_factor),'">',            '     <section name="damage" />','     <help> scaling exponent (default is 3) </help>','</parameter>');
- 
-        end % }}}
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="law" type="',            class(obj.law),'" default="',                num2str(obj.law),'">',   '     <section name="damage" />','     <help> damage law (string) from {"undamaged","pralong"} </help>','</parameter>');
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="spcdamage" type="',      class(obj.spcdamage),'" default="',          num2str(obj.spcdamage),'">',            '     <section name="damage" />','     <help> damage constraints (NaN means no constraint) </help>','</parameter>');
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="max_damage" type="',     class(obj.max_damage),'" default="',         num2str(obj.max_damage),'">',            '     <section name="damage" />','     <help> maximum possible damage (0&amp;lt;=max_damage&amp;lt;1) </help>','</parameter>');
+
+			% stabilization (0,1, or 2) drop-down
+			fprintf(fid,'%s\n%s\n%s\n%s\n',    '<parameter key ="stabilization" type="alternative" optional="false">','     <section name="damage" />','     <help> 0: no, 1: artificial_diffusivity, 2: SUPG </help>');
+			fprintf(fid, '%s\n', '       <option value="0" type="string" default="true"></option>');
+			fprintf(fid, '%s\n', '       <option value="1" type="string" default="false"></option>');
+			fprintf(fid, '%s\n', '       <option value="2" type="string" default="false"></option>');
+			fprintf(fid, '%s\n','</parameter>');
+
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="maxiter" type="',             class(obj.maxiter),'" default="',   num2str(obj.maxiter),'">',   '     <section name="damage" />','     <help> maximum number of non linear iterations </help>','</parameter>');
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="penalty_lock" type="',        class(obj.penalty_lock),'" default="',            num2str(obj.penalty_lock),'">',            '     <section name="damage" />','     <help> stabilize unstable damage constraints that keep zigzagging after n iteration (default is 0, no stabilization) </help>','</parameter>');
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="penalty_threshold" type="',   class(obj.penalty_threshold),'" default="',            num2str(obj.penalty_threshold),'">',            '     <section name="damage" />','     <help> threshold to declare convergence of damage evolution solution (default is 0) </help>','</parameter>');
+			fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',        '<parameter key ="penalty_factor" type="',      class(obj.penalty_factor),'" default="',            num2str(obj.penalty_factor),'">',            '     <section name="damage" />','     <help> scaling exponent (default is 3) </help>','</parameter>');
+
+		end % }}}
         
 		function obj = damage(varargin) % {{{
@@ -109,5 +109,5 @@
 			obj.isdamage=0;
 			obj.D=0;
-			obj.law='undamaged';
+			obj.law=0;
 			
 			obj.max_damage=1-1e-5; %if damage reaches 1, solve becomes singular, as viscosity becomes nil
@@ -148,5 +148,5 @@
 			md = checkfield(md,'fieldname','damage.isdamage','values',[1,0]);
 			if obj.isdamage,
-				md = checkfield(md,'fieldname','damage.law','values',{'undamaged','pralong'});
+				md = checkfield(md,'fieldname','damage.law','numel',[1],'values',[0,1,2]);
 				md = checkfield(md,'fieldname','damage.D','>=',0,'<=',obj.max_damage,'size',[md.mesh.numberofvertices 1]);
 				md = checkfield(md,'fieldname','damage.spcdamage','forcing',1);
@@ -155,10 +155,7 @@
 				md = checkfield(md,'fieldname','damage.maxiter','>=0',0);
 				md = checkfield(md,'fieldname','damage.elementinterp','values',{'P1','P2'});
-				md = checkfield(md,'fieldname','damage.penalty_factor','>=0',0);
-				md = checkfield(md,'fieldname','damage.penalty_lock','>=0',0);
-				md = checkfield(md,'fieldname','damage.penalty_threshold','>=0',0);
-			end
-
-			if strcmpi(obj.law,'pralong'),
+				md = checkfield(md,'fieldname','damage.penalty_factor','>=',0);
+				md = checkfield(md,'fieldname','damage.penalty_lock','>=',0);
+				md = checkfield(md,'fieldname','damage.penalty_threshold','>=',0);
 				md = checkfield(md,'fieldname','damage.healing','>=',0);
 				md = checkfield(md,'fieldname','damage.c1','>=',0);
@@ -169,12 +166,9 @@
 				md = checkfield(md,'fieldname','damage.equiv_stress','numel',[1],'values',[0 1]);
 				md = checkfield(md,'fieldname','damage.requested_outputs','stringrow',1);
-			elseif strcmpi(obj.law,'undamaged'),
+			elseif (obj.law~=0),
 				if (solution==DamageEvolutionSolutionEnum),
 					error('Invalid evolution law (md.damage.law) for a damage solution');
 				end
-			else 
-				error('invalid damage evolution law');
-			end
-
+			end
 		end % }}}
 		function list=defaultoutputs(self,md) % {{{
@@ -191,5 +185,5 @@
 			fielddisplay(obj,'isdamage','is damage mechanics being used? {true,false}');
 			if obj.isdamage,
-				fielddisplay(obj,'law','damage law (string) from {''undamaged'',''pralong''}');
+				fielddisplay(obj,'law','damage law {''0: undamaged'',''1: pralong''}');
 				fielddisplay(obj,'D','damage tensor (scalar)');
 				fielddisplay(obj,'spcdamage','damage constraints (NaN means no constraint)');
@@ -202,7 +196,4 @@
 				fielddisplay(obj,'penalty_threshold','threshold to declare convergence of damage evolution solution (default is 0)');
 				fielddisplay(obj,'penalty_factor','scaling exponent (default is 3)');
-			end
-
-			if strcmpi(obj.law,'pralong'),
 				fielddisplay(obj,'c1','damage parameter 1');
 				fielddisplay(obj,'c2','damage parameter 2');
@@ -220,5 +211,5 @@
 			WriteData(fid,'object',obj,'fieldname','isdamage','format','Boolean');
 			if obj.isdamage,
-				WriteData(fid,'object',obj,'fieldname','law','format','String');
+				WriteData(fid,'object',obj,'fieldname','law','format','Integer');
 				WriteData(fid,'object',obj,'fieldname','D','format','DoubleMat','mattype',1);
 				WriteData(fid,'object',obj,'fieldname','spcdamage','format','DoubleMat','mattype',1,'forcinglength',md.mesh.numberofvertices+1);
@@ -227,11 +218,8 @@
 				WriteData(fid,'object',obj,'fieldname','stabilization','format','Integer');
 				WriteData(fid,'object',obj,'fieldname','maxiter','format','Integer');
-				WriteData(fid,'object',obj,'fieldname','elementinterp','format','String');
+				WriteData(fid,'enum',DamageElementinterpEnum(),'data',StringToEnum(obj.elementinterp),'format','Integer');
 				WriteData(fid,'object',obj,'fieldname','penalty_threshold','format','Integer');
 				WriteData(fid,'object',obj,'fieldname','penalty_lock','format','Integer');
 				WriteData(fid,'object',obj,'fieldname','penalty_factor','format','Double');
-			end
-	
-			if strcmpi(obj.law,'pralong'),
 				WriteData(fid,'object',obj,'fieldname','c1','format','Double');
 				WriteData(fid,'object',obj,'fieldname','c2','format','Double');
Index: issm/trunk/src/m/classes/damage.py
===================================================================
--- issm/trunk/src/m/classes/damage.py	(revision 18081)
+++ issm/trunk/src/m/classes/damage.py	(revision 18301)
@@ -19,5 +19,5 @@
 		self.isdamage           = 0.
 		self.D						= float('NaN')
-		self.law						= ''
+		self.law						= float('NaN')
 		self.spcdamage				= float('NaN')
 		self.max_damage			= float('NaN')
@@ -53,5 +53,5 @@
 		if self.isdamage:
 			s+="%s\n" % fielddisplay(self,"D","damage tensor (scalar for now)")
-			s+="%s\n" % fielddisplay(self,"law","damage law (string) from ['undamaged','pralong']")
+			s+="%s\n" % fielddisplay(self,"law","damage law ['0: undamaged','1: pralong']")
 			s+="%s\n" % fielddisplay(self,"spcdamage","damage constraints (NaN means no constraint)")
 			s+="%s\n" % fielddisplay(self,"max_damage","maximum possible damage (0<=max_damage<1)")
@@ -63,6 +63,4 @@
 			s+="%s\n" % fielddisplay(self,"penalty_threshold","threshold to declare convergence of damage evolution solution (default is 0)")
 			s+="%s\n" % fielddisplay(self,"penalty_factor","scaling exponent (default is 3)")
-
-		if (self.law=='pralong'):
 			s+="%s\n" % fielddisplay(self,"c1","damage parameter 1 ")
 			s+="%s\n" % fielddisplay(self,"c2","damage parameter 2 ")
@@ -81,5 +79,5 @@
 		self.isdamage=0
 		self.D=0
-		self.law='undamaged'
+		self.law=0
 
 		self.max_damage=1-1e-5 #if damage reaches 1, solve becomes singular, as viscosity becomes nil
@@ -132,5 +130,5 @@
 			md = checkfield(md,'fieldname','damage.D','>=',0,'<=',self.max_damage,'size',[md.mesh.numberofvertices])
 			md = checkfield(md,'fieldname','damage.max_damage','<',1,'>=',0)
-			md = checkfield(md,'fieldname','damage.law','values',['undamaged','pralong'])
+			md = checkfield(md,'fieldname','damage.law','numel',[1],'values',[0,1,2,3])
 			md = checkfield(md,'fieldname','damage.spcdamage','forcing',1)
 			md = checkfield(md,'fieldname','damage.stabilization','numel',[1],'values',[0,1,2])
@@ -140,6 +138,4 @@
 			md = checkfield(md,'fieldname','damage.penalty_lock','>=0',0)
 			md = checkfield(md,'fieldname','damage.penalty_threshold','>=0',0)
-
-		if self.law == 'pralong':
 			md = checkfield(md,'fieldname','damage.healing','>=',0)
 			md = checkfield(md,'fieldname','damage.c1','>=',0)
@@ -151,5 +147,5 @@
 			md = checkfield(md,'fieldname','damage.equiv_stress','numel',[1],'values',[0,1])
 			md = checkfield(md,'fieldname','damage.requested_outputs','stringrow',1)
-		elif m.strcmpi(self.law,'undamaged'):
+		elif self.law != 0:
 			if (solution==DamageEvolutionSolutionEnum):
 				raise RuntimeError('Invalid evolution law (md.damage.law) for a damage solution')
@@ -162,15 +158,13 @@
 		if self.isdamage:
 			WriteData(fid,'object',self,'fieldname','D','format','DoubleMat','mattype',1)
-			WriteData(fid,'object',self,'fieldname','law','format','String')
+			WriteData(fid,'object',self,'fieldname','law','format','Integer')
 			WriteData(fid,'object',self,'fieldname','spcdamage','format','DoubleMat','mattype',1,'forcinglength',md.mesh.numberofvertices+1)
 			WriteData(fid,'object',self,'fieldname','max_damage','format','Double')
 			WriteData(fid,'object',self,'fieldname','stabilization','format','Integer')
-			WriteData(fid,'object',self,'fieldname','elementinterp','format','String')
+			WriteData(fid,'object',self,'fieldname','maxiter','format','Integer')
+			WriteData(fid,'enum',DamageElementinterpEnum(),'data',StringToEnum(self.elementinterp)[0],'format','Integer')
 			WriteData(fid,'object',self,'fieldname','penalty_threshold','format','Integer')
-			WriteData(fid,'object',self,'fieldname','maxiter','format','Integer')
 			WriteData(fid,'object',self,'fieldname','penalty_lock','format','Integer')
 			WriteData(fid,'object',self,'fieldname','penalty_factor','format','Double')
-
-		if self.law=='pralong':
 			WriteData(fid,'object',self,'fieldname','c1','format','Double')
 			WriteData(fid,'object',self,'fieldname','c2','format','Double')
